


unit
   t_rectangle;
   
uses
   t_drawobj,
   t_line;
   
   
interface

type
   p_line      = ^t_line;
   t_rectangle = object(t_drawobj)
                   filled : boolean;
                   line : array[0..4]of p_line;
                   constructor Init(c : p_colormap; a : p_point2d; n : p_drawobj; ep : p_point2d);                
                   
                   procedure Draw;			virtual;
                   procedure Select(p : p_drawobj);	virtual;
                   procedure UnSelect(p : p_drawobj);   virtual;
                 end;

implementation

procedure t_rectangle.Init;
var	
   p : array[0..4] of p_point2d;
   i : integer;
begin
  new(p[1]);
  new(p[3]);
  
  p[0] := a;
  
  p[1]^.x := ep^.x;
  p[1]^.y := a^.y;
  
  p[2] := ep;
  
  p[3]^.x = a^.x;
  p[3]^.y = ep^.y;
  
  p[4] := a;
  
  line[4] := NIL;
  
  for i:=0 to 3 do
  begin 
     new(line[i]);
     line[i]^.Init(c,p[i],line[i+1],p[i+1]);  
  end;
  
  delete(p[1]);
  delete(p[3]); 
  
  filled := false;
  
  t_drawobj.Init(c,a,n);
end;

procedure t_rectangle.Draw;
var
   i : integer;
begin
  for i:=0 to 3 do
     line[i]^.Draw;
end;

procedure t_rectangle.Select;
var
   i : integer;
begin
  t_drawobj.Select(p);
  
  if (selected)
     then for i:=0 to 3 do
            line[i]^.selected := true;
end;

procedure t_rectangle.UnSelect;
var
   i : integer;
begin
  t_drawobj.Select(p);
  
  if (selected = false)
     then for i:=0 to 3 do
            line[i]^.selected := false;
end;

begin
end.      
