/* 
 * Thomas Pantzer: t_drawgrp.cc, v0.1b  8.11.98 0:58 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */




#include "t_drawgrp.h"
#include <stdlib.h>

void t_drawgrp::Init(t_colormap *c, t_vector2d *a, t_drawobj *n, int lw)
{
  t_drawobj::Init(c,a,n,lw);
  kind = _group;
  first = NULL;
  count = 0;
}

void t_drawgrp::SaveMeToo(int fd)
{
      char st[256];
      sprintf(st,"\tcnt:%d",count);
      write(fd,st,strlen(st));
}

void t_drawgrp::SaveTo(int fd)
{
      t_drawobj::SaveTo(fd);
      
      SaveMeToo(fd);
      
      if (first != NULL)
      	 first->SaveAllTo(fd);
}

void t_drawgrp::Add(t_drawobj *p)
{
   if ((p == NULL) || (p == this))   // no recursive adds
      return;
      
   if (first == NULL)
      {
       first = p;
       anchor.Init(&p->anchor);
       count = 1;
      } 
    else  
      {
       first->Insert(p);
       NewAnchor();
       
//       anchor.x = (count * anchor.x) + p->anchor.x;
//       anchor.y = (count * anchor.y) + p->anchor.y;
       
       count++;

//       anchor.x /= count;
//       anchor.y /= count;
      } 
}
 
void t_drawgrp::Remove(t_drawobj *p)
{
   if (p == NULL)
      return;

   if (first == p)
      {
       t_drawobj *delp;
       
       delp = first;
       first = delp->next;
       delp->Done();
       delete delp;
      }
    else first->Delete(p);

//    AnchorInit();
} 


void t_drawgrp::Draw(color_type ct)
{
#ifdef DEBUG
   fprintf(stderr, "t_drawgrp::Draw()\n");    
#endif   
   if (first !=  NULL)
      first->DrawAll(ct);
}

/*
void t_drawgrp::Show(void)
{
   first->ShowAll();
}

void t_drawgrp::Hide(void)
{
   first->HideAll();
}
*/

void t_drawgrp::Select(char b)
{
   t_drawobj::Select(b);
   
   if (first != NULL)
      first->SelectAll(b);
}


void t_drawgrp::Opaque(char b)
{
   t_drawobj::Opaque(b);
   
   if (first != NULL)
      first->OpaqueAll(b);
}


void t_drawgrp::AnchorAdd(t_vector2d *V)
{
   t_drawobj *p;
 
   t_drawobj::AnchorAdd(V);
   
   p = first;
   while (p != NULL)
     {
      p->AnchorAdd(V);
      
      p = p->next;
     }
}

void t_drawgrp::NewAnchor(void)
{
    anchor.Init(0,0);
    
    t_drawobj *p = first;
    int c = 0;
    
    while (p != NULL)
      {
       anchor.Add(&p->anchor);
       p = p->next;
       c++;
      }
      
    if (c > 0)
       anchor.Mult(1.0/(double)c);
}

void t_drawgrp::Rotate(t_vector2d *M, t_vector2d &CSR)
{
   fprintf(stderr,"t_drawgrp::Rotate(0x%08lx)\n",(long)this); 

   if (first != NULL)
      first->RotateAll(M,CSR);

   t_drawobj::Rotate(M,CSR);
}
