



#ifndef SCANNER_H
#define SCANNER_H

#include <linux/scanner.h>

#include "graphic_types.h"

#define max_scan_bytes (207*8*3)
#define max_image_size (max_scan_bytes * (max_scan_bytes*5))

#define bool	char

class t_scanner_image {
public:
		 int width,height,depth,bpl,bpp;
		 unsigned char *buffer;
		 unsigned long int size;
	
		void Init(int w, int h, int d);
		void Resize(int w, int h, int d);
		void Done(void);	
		char GetPixel_(int x, int y, t_color_3i *color);	
		char SetPixel_(int x, int y, t_color_3i *color);	
		void Cut(int x1, int y1, int x2, int y2);	
};

class t_scanner {
   public:
      bool working;
      scanner_type type;
      modeinfo_struct mode;
      unsigned long int bptr,scanned_size;
      int _Width,_Depth,_Height;
      int max_lines,mode_num;
      char devnm[256];
       
      t_scanner_image *__Image;	
      
      bool Init(char *devnm);
      void Done(void);
      
      bool GetMode(void);
      int GetType(void);
      int  SetMode(int m);
      
/*      void Start(void);*/
      void Start(int mod);
      bool Callback(void);
      void Stop(void);
      void Rotate(void);
      void Mirror(void);
      virtual void Resize(void);
      /* char GetImage(char *,int max_size);      */
      
   private:
      int fd;   
      void GetPixel(int x, int y, t_color_3i &Pixel, t_scanner_image *buffer);
      void SetPixel(int x, int y, t_color_3i Pixel, t_scanner_image *buffer);
      	
      
};

typedef struct {
         int ID;
         char name[256];
       } t_scanner_mode;


extern modeinfo_struct modeinfo[];
extern t_scanner_mode scanner_mode[];


#ifdef MAIN_G
#define vextern
#else
#define vextern extern
#endif


vextern t_scanner Scanner;
// vextern char *BitImage; 
vextern unsigned long int ScanOffset;
#undef vextern
#endif
