
#include <X11/xpm.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "forms.h"

//#include "utils.h"

#define MAIN_G

#include "xfscan.h"
//#include "fbrowse.h"
//#include "graphix.h"
#include "t_scanner.h"
#include "minidraw.h"
#include "stuff.h"
#include "xfgc/xfbgi.h"

#include "copyright.h"

#include <errno.h>

#define ErrorMsg  perror

#ifndef SCANDEV
#define SCANDEV	"/dev/scanner"
#endif



void fileload_cb(char *fn, int mode)
{
}


void filesave_cb(const char *fn, int mode)
{
#ifdef DEBUG
    fprintf(stderr,"filesave to [%s] with mode %d\n",fn,mode);
#endif

    int fd,l,wr;
    char st[256];
 
    if (mode == 3)
       {
       	strcpy(st,fn);
        VScr.Save(st);
        return;
       }
       
    fd = open(fn,O_RDWR|O_CREAT|O_TRUNC,0644);
    if (fd < 0)
        return;
    
    switch (mode)
      {
       case 0: // ppm
         sprintf(st,"P6\n"
                    "%d %d\n"
                    "%d\n",Scanner.__Image->width,Scanner.__Image->height,255);
         break;           
                    
       case 1: // pgm
         sprintf(st,"P5\n"
                    "%d %d\n"
                    "%d\n",Scanner.__Image->width,Scanner.__Image->height,255);
         break;
         
       case 2: // pbm
         sprintf(st,"P4\n"
                    "%d %d\n",Scanner.__Image->width,Scanner.__Image->height);
         break;
       
       default:             
       case 3: // xpm
         close(fd); 
         return;
         break;
      }              
      

    l = strlen(st);           
    wr = write(fd,&st[0],l);           
    if (wr != l)
       return;

    write(fd,&Scanner.__Image->buffer[0],Scanner.__Image->height*Scanner.__Image->bpl);   

    close(fd);  
}



int DisplayConvMode(int scd, int dpd)
{
   return (scd*100) + dpd;
}   

/*
int absmin(int x, int y)
{
   if (x < 0)
      x = -x;
       
   if (y < 0)
      y = -y;
      
   if (x < y)
      return x;
    else
      return y;  
}
*/


void GetPix(int x, int y, t_color_3i *C)
{
	Scanner.__Image->GetPixel_(x,y,C);
}


void Bitmap2XImage(char fast)
{
   long int start,byteoffset,lines;
   XImage *ximg;
   void *data;
   unsigned char *bdata;
   unsigned short *sdata;
   unsigned int width,height;

#ifdef DEBUG       
       fprintf(stderr,"Bitmap2XImage fast==%d\n",fast);
#endif

   if (Scanner.__Image == NULL)
      {
#ifdef DEBUG
       fprintf(stderr,"ScannerImage == NULL\n");
#endif       
       return;
      } 

   height = Scanner.scanned_size / Scanner.__Image->bpl;

   if ((height <= ScanOffset) && (fast == true))
      {
#ifdef DEBUG
       fprintf(stderr,"nothing to do -- height:%d\tsize:%ld\toffset:%ld\n",
                  height,Scanner.scanned_size,ScanOffset);
#endif
       return;     
      } 

   lines = (height - ScanOffset) / Matrix;
   byteoffset = ScanOffset * Scanner.__Image->bpl;

   int we = Scanner.__Image->width / Matrix;  
   int ws = 0; 
   int W = we - ws;

   if (fl_get_button(fd_xfscan->stripe_bt) != 0)
      {
       W /= 4;
       ws = Scanner.__Image->width / 5;
       we = ws + W;
      } 



#ifndef OLD_STYLE
	t_area Crop;
	t_vertex_2i Off;
	
	Crop.UL.y = ScanOffset;
	Crop.UL.x = ws;
	
	Crop.BR.y = ScanOffset + lines;
	Crop.BR.x = we;
	
	Off.x = 0;
	Off.y = 0;
	
	VScr.PutPPMImage(&Off,GetPix,&Crop,Matrix);
#else
   switch (VScr.depth)
     {
      case 8:  
      case 16:
        {
         if (VScr.depth == 16)
             data = malloc(W*lines*sizeof(short));
          else   
             data = malloc(W*lines*sizeof(char));
              
         if (data == NULL)
            return;
            
         ximg = XCreateImage(VScr.dpy,VScr.visual,
                                VScr.depth,
                                ZPixmap,0,NULL,
                                W,lines,
                                32,
                                0);
#ifdef DEBUG
//	 fprintf(stderr,"XCreateImage: 0x%08lx\n",(long)ximg->data);
#endif
         sdata = (unsigned short *)data;
         bdata = (unsigned char *)data;
         ximg->data = (char *)&(data[0]);
 
 
 	 for (int i=0; i<lines; i++)
	   {
	    for (int j=ws; j<we; j++)
	      {
	       int r,g,b;	
	       r = g = b = 0;
	       
	       for (int p=0; p<Matrix; p++)
	         {
			  for (int q=0; q<Matrix; q++)
		    	{
		    	 t_scanner_color	sc;	
		    	 Scanner.__Image->GetPixel((j*Matrix)+p,(i*Matrix)+ScanOffset+q,&sc);
		    	 r += sc.red;
		    	 g += sc.green;
		    	 b += sc.blue; 
		    	}
			 }	



	       r /= (Matrix*Matrix);		
	       g /= (Matrix*Matrix);		
	       b /= (Matrix*Matrix);		

	       int n = (i * W) + (j - ws);	       
	       	   	
	       int R,G,B;
	       switch(VScr.depth)
	       	 {
		  case 16:
                    R = ((r << 8) & 0xf800);
                    G = ((g << 3) & 0x07e0);
                    B = ((b >> 3) & 0x001f);
                    sdata[n] = (R|G|B) & 0xffff;                     
		    break;

		  case 8:  
                    R = ((r >> 5) & 0x07);
                    G = ((g >> 2) & 0x38);
                    B =  (b & 0xc0);
                    bdata[n] = (R|G|B) & 0xff;                     
		    break;
		    
		  case 1:  
		  case 24:
		  default:
		    fprintf(stderr,"visual depth %d not yet supported\n",VScr.depth); 
		    break;  
		 }
	      }			 
	   }	        

	int hs1 = ScanOffset / Matrix;
	unsigned int hs2 = lines;
	           
#ifdef DEBUG       
//         fprintf(stderr,"XPutImage(0x%08lx,%d,%d,%d,%d)\n",VScr.win,ws,hs1,W,hs2);
#endif

         PutImage(ximg,0,0,ws,hs1,W,hs2);
         ScanOffset += lines;

//         fprintf(stderr,"XDestroy\n");                                   
         XDestroyImage(ximg);  // calls ximage_p->destroy_image()            
         ximg = NULL;                                                            
        }
        break;  // case 8 or 16

      case 1:
      case 24:
      default:
        // try to use the provided image directly in the XImage
        // show a bar if mode doesn't match
 	fprintf(stderr,"visual depth %d not yet supported\n",VScr.depth); 
        break;
        
     }  // switch VScr.depth
#endif
}



void Update_Display(char fast)
{
#ifdef DEBUG       
	fprintf(stderr,"Update_Display(fast==%d)\n",fast);
#endif
	Bitmap2XImage(fast);

#ifdef DEBUG       
	fprintf(stderr,"RootObj.ShowAll\n");
#endif
	RootObj.ShowAll();
}



void Main_ExitProc(int lvl)
{
	Scanner.Done();
	exit(lvl);
}


int main(int argc, char *argv[])
{
	if (Scanner.Init(SCANDEV) == false)
	   {
	    ErrorMsg("scanner init");
	    return -1;
	   } 

	fl_initialize(&argc, argv, 0, 0, 0);

	fd_xfscan = create_form_xfscan();
	fd_odraw = create_form_odraw();

	/* fill-in form initialization code */
	int defvis,d;
   
	defvis = fl_get_vclass();
   
	for (int i=1; i<argc; i++)
	    {
	     if (sscanf(argv[i],"-v%d",&d) == 1)
		     defvis = d;	
	    }
   
	fprintf(stderr,"default visual:%d\n",defvis);
   
	VScr.Init(defvis);
	VScr.BackingStore(true);
   
	/* show the first form */
//	fl_set_graphics_mode (gmode[4].mode, 0);     
	VScr.Show("xfscan canvas");

	fl_add_canvas_handler(VScr.fd_xfbgi->canvas, ButtonPress, canvas_mouse, VScr.fd_xfbgi);
	fl_add_canvas_handler(VScr.fd_xfbgi->canvas, ButtonRelease, canvas_mouse, VScr.fd_xfbgi);
	fl_add_canvas_handler(VScr.fd_xfbgi->canvas, MotionNotify, canvas_mouse, VScr.fd_xfbgi);
	fl_add_canvas_handler(VScr.fd_xfbgi->canvas, KeyPress, canvas_mouse, VScr.fd_xfbgi);
	fl_add_canvas_handler(VScr.fd_xfbgi->canvas, KeyRelease, canvas_mouse, VScr.fd_xfbgi);
	fl_set_object_prehandler(VScr.fd_xfbgi->canvas, preemptive_handler);

	ObjMode = 0;  // line
	EditMode = 0;  // add
	grid = 20;
	FillStyle = 0; // empty
	VScr.TextFont = 0; // vga font
	addingtext = false;
	Matrix = 1;
    
	t_vector2d P;
	P.Init(-800,-800);
   
	CursorObj.Init(&CM[7],&P,NULL,5,1);
	RootObj.Init(&CM[0],&P,&CursorObj,VScr.LineWidth);
	ActualObj = NULL;
	ScanOffset = 0;
	cutmode = uninitialized;
   
//   fl_set_graphics_mode (gmode[3].mode, 0);     
	fl_show_form(fd_xfscan->xfscan,FL_PLACE_MOUSE,FL_FULLBORDER,"xfscan");

	while (true)
	   fl_do_forms();
      
	return 0;
}














































/*
         for (int i=0; i<lines; i++)
           {
            int k = (i * Scanner.__Image->bpl)+byteoffset;
           
            for (int j=ws; j<we; j++)
              {
//               if (fast == true)
//                  {
//                   if ((j > Scanner.width/16) && (j < (Scanner.width*15)/16))
//                      continue;
//                  }
                  
               int n = (i*W)+(j-ws);
              
               int r,g,b,R,G,B;
               
               r = 0;
               g = 0;
               b = 0;
                     
               switch(Scanner._Depth)
                 {
                  case 24: // 8bit true color
                    {
                     int l = k+(j*3);
                     r = Scanner.__Image->buffer[l+0];
                     g = Scanner.__Image->buffer[l+1];
                     b = Scanner.__Image->buffer[l+2];
                    } 
                    break;
                       
                  case 8: // gray level
                    {
                     int l = k+j;
                     r = Scanner.__Image->buffer[l];
                     g = Scanner.__Image->buffer[l];
                     b = Scanner.__Image->buffer[l];
                    }
                    break;

		  case 18:                    
                    fprintf(stderr,"Scanner.depth %d not implemented\n",Scanner._Depth);
		    break;

                  case 12: // 4bit true color
                    {
                     int l = k+((j*3)/2);
                     
                     if ((j % 2) == 0)
                        {
                         r = Scanner.__Image->buffer[l] & 0xf0;
                         g = (Scanner.__Image->buffer[l] << 4) & 0xf0;
                         b = Scanner.__Image->buffer[l+1] & 0xf0;
                        }
                      else   
                        {
                         r = (Scanner.__Image->buffer[l] << 4) & 0xf0;
                         g = Scanner.__Image->buffer[l+1] & 0xf0;
                         b = (Scanner.__Image->buffer[l+1] << 4) & 0xf0;
                        }
                    }
                    break;  
  
                  case 1:
                    {
                     int p,q,m,x;
                     long z;
                     char t,u,v,y;

                     p = (j*Matrix) / 8;
                     q = (j*Matrix) % 8;      // 0..7
                     m = 0x80 >> q;
                     
                     t = Scanner.__Image->buffer[k+p];
                     
                     switch (Matrix)
                       {
                        case 1:
                          if ((t & m) > 0)  
                             {
                              r = 0xff; 
                              g = 0xff; 
                              b = 0xff; 
                             }
                          break;
                          
                        case 4:
                          u = Scanner.__Image->buffer[k+p+Scanner.__Image->bpl];
                          v = Scanner.__Image->buffer[k+p+(Scanner.__Image->bpl*2)];
                          y = Scanner.__Image->buffer[k+p+(Scanner.__Image->bpl*3)];
                          m = 0xf0 >> q;
                          
                          z = 0;
                          for (int I=0; I<4; I++)
                            {
                             if ((t & (0x80 >> (I+q))) > 0)
                                z++;
                             
                             if ((u & (0x80 >> (I+q))) > 0)
                                z++;
                             
                             if ((v & (0x80 >> (I+q))) > 0)
                                z++;
                             
                             if ((y & (0x80 >> (I+q))) > 0)
                                z++;
                            }
                            
                          r = b = g = (z*16)-1;
                          break;  
                          
                        case 2:
                          u = Scanner.__Image->buffer[k+p+Scanner.__Image->bpl];
                          m = 0xc0 >> q;
                   //       v = 0xc0 >> q;
                         
                          x = ((t & m) << q) | ((u & m) << (q+2));
                          
                          switch (x)
                            {
                             case 0x3c0: // 4
                               r = g = b = 0xff;
                               break;
                               
                             case 0x1c0: // 3
                             case 0x2c0:
                             case 0x380:
                             case 0x340:
                               r = g = b = 0xc0;
                               break;
                             
                             case 0x0c0: // 2
                             case 0x300:
                             case 0x180:
                             case 0x140:
                             case 0x280:
                             case 0x240:
                               r = g = b = 0x80;
                               break;
                              
                             case 0x200: // 1
                             case 0x100:  
                             case 0x080:
                             case 0x040:
                               r = g = b = 0x40;
                               break;
                            } 
                          break;      
                       } 
                    }
                    break;
                 }   
                          
              if (VScr.depth == 16)
                 { 
                  R = ((r << 8) & 0xf800);
                  G = ((g << 3) & 0x07e0);
                  B = ((b >> 3) & 0x001f);
                  sdata[n] = (R|G|B) & 0xffff;                     
                 }
               else
                 {
                  R = ((r >> 5) & 0x07);
                  G = ((g >> 2) & 0x38);
                  B =  (b & 0xc0);
                  bdata[n] = (R|G|B) & 0xff;                     
                 }   
              }  // for all pixels     
           }  // for all lines   
*/
